import numpy as np
import matplotlib.pyplot as plt
import numpy.linalg as la
import yaml
import os
from skimage.metrics import peak_signal_noise_ratio as psnr
num_projs = 25
# num_projs = 30
# num_projs = 20

folder_name = '/data/bowen/SparseReconstruction/3d-ct-full-dose/proj_25_ood'
img_path = '/data/bowen/SparseReconstruction/3d-ct-full-dose/'
gt = np.load("test_fbp_gt.npy")[0,0,:,:].T
plt.imshow(gt, "gray")
image = gt.copy()
shape_min = min(image.shape)
radius = shape_min // 2
img_shape = np.array(image.shape)
coords = np.array(np.ogrid[:gt.shape[0], :gt.shape[1]],
                          dtype=object)
dist = ((coords - img_shape // 2) ** 2).sum(0)
outside_reconstruction_circle = dist > radius ** 2
gt = 0*outside_reconstruction_circle + gt * (1-outside_reconstruction_circle)

def crop_img(img):
    return 0*outside_reconstruction_circle + img * (1-outside_reconstruction_circle)



def set_state(config_file,state_name, value):
    doc = None
    with open(config_file, 'r') as f:
        doc = yaml.safe_load(f)
        doc[state_name] = value
        
    with open(config_file, 'w') as f:
        new_yaml = yaml.dump(doc,f)
        
    
    return 



prefix = 'c'
offset = 0
for i in range(300):
    if i >= 100:
        prefix = 'b'
        offset = -100
    if i >= 200:
        prefix = 'a'
        offset = -200
    
    print(i,"iteration")
    res_path = '/data/bowen/SparseReconstruction/3d-ct-full-dose/gt_ood_cropped/' + prefix + '_' + str(i+offset) + '.npy'
    recon_path = img_path + 'lasso-tv/' + 'recon_' + prefix + '-' + str(i+offset) + '.npy'
    set_state('configs/ct_recon_tv.yaml', 'num_projs', num_projs)
    set_state('configs/ct_recon_tv.yaml', 'img_path', res_path)
    set_state('configs/ct_recon_tv.yaml', 'recon_name', recon_path)
    set_state('configs/ct_recon_tv.yaml', 'reg', 'lasso')
    set_state('configs/ct_recon_tv.yaml', 'reg', 'res-lasso')
    set_state('configs/ct_recon_tv.yaml', 'prior_index', i)
    set_state('configs/ct_recon_tv.yaml', 'lr', 0.002)
    set_state('configs/ct_recon_tv.yaml', 'max_iter', 4000)
    
    os.system('python TV-prior_image.py --config configs/ct_recon_tv.yaml --output_path  /data/bowen/SparseReconstruction/3d-ct-full-dose/models')

    gt = np.load("/data/bowen/SparseReconstruction/3d-ct-full-dose/gt_ood_cropped/" + 'a' + "_" + str(15) + ".npy")
    img = np.load(recon_path)[0,:,:,0]
    print(psnr(gt, np.clip(crop_img(img),0,1)))
    np.save(recon_path, np.clip(crop_img(img),0,1))
#     
