
import numpy as np
# import pandas as pd
from skimage.metrics import peak_signal_noise_ratio as psnr
from skimage.metrics import structural_similarity as ssim
num_projs = 25
# num_projs = 30
# num_projs = 20

folder_name = '/data/bowen/SparseReconstruction/3d-ct-full-dose/proj_25_ood'
img_path = '/data/bowen/SparseReconstruction/3d-ct-full-dose/'
gt = np.load("test_fbp_gt.npy")[0,0,:,:].T
image = gt.copy()
shape_min = min(image.shape)
radius = shape_min // 2
img_shape = np.array(image.shape)
coords = np.array(np.ogrid[:gt.shape[0], :gt.shape[1]],
                          dtype=object)
dist = ((coords - img_shape // 2) ** 2).sum(0)
outside_reconstruction_circle = dist > radius ** 2
gt = 0*outside_reconstruction_circle + gt * (1-outside_reconstruction_circle)

prefix = 'c'
offset = 0

def crop_img(img):
    return 0*outside_reconstruction_circle + img * (1-outside_reconstruction_circle)



results = np.zeros((300,10))
for i in range(300):
    if i >= 100:
        prefix = 'b'
        offset = -100
    if i >= 200:
        prefix = 'a'
        offset = -200

        
    res = np.load('/data/bowen/SparseReconstruction/3d-ct-full-dose/resnerp_denoise/resrecon_' + prefix + '-' + str(i+offset) + '.npy')[0,:,:,0]
    recon1 = np.load("/data/bowen/SparseReconstruction/3d-ct-full-dose/nerprecon/nerp_recon" + "-" + str(i) + ".npy")
    res_fbp = np.load("/data/bowen/SparseReconstruction/3d-ct-full-dose/res_fbp_noise/res_" + str(i) + ".npy")
    gt = np.load("/data/bowen/SparseReconstruction/3d-ct-full-dose/gt_ood_cropped/" + prefix + "_" + str(i+offset) + ".npy")
    prior = np.load("/data/bowen/SparseReconstruction/3d-ct-full-dose/cnn_recon/prior" + str(i) + ".npy")[0,:,:,0]
    ridge_boost = np.load("/data/bowen/SparseReconstruction/3d-ct-full-dose/ridge_boost/" +prefix + "-" + str(i+offset) + ".npy")
#    ridge_boost = np.load("/data/bowen/SparseReconstruction/3d-ct-full-dose/ridge_boost/nerp" +prefix + "-" + str(i+offset) + ".npy")[0,:,:,0]
    tv = np.load(img_path + 'lasso-tv/' + 'recon_' +prefix + '-' + str(i+offset) + '.npy')
    
    
    stage1_recon = np.clip(crop_img(recon1),0,1)
    alpha, beta,gamma = 1.2,.8,1.6
    if i >= 100:
        alpha,beta=1.5,.5
    if i >= 200:
        alpha, beta = 1.2,.8


    tv_recon = np.clip(tv, 0, 1)
    resn, resr, rest = crop_img(res), crop_img(ridge_boost), crop_img(tv_recon - prior)
    stage1_recon = np.clip(crop_img(recon1),0,1)
    stage2_recon = np.clip(prior+(resn*alpha+resr*beta)/(gamma),0,1)
    stage3_recon = np.clip(prior + (resn* alpha + resr* beta + rest*1)/(gamma*1.25),0,1)
    fbp_recon = np.clip(prior +1* res_fbp, 0,1)
    
    ##tv, s1, s2, s3 
    results[i,0] = psnr(gt, fbp_recon)
    results[i,1] = psnr(gt, tv_recon)
    results[i,2] = psnr(gt, stage1_recon)
    results[i,3] = psnr(gt, stage2_recon)
    results[i,4] = psnr(gt, stage3_recon)
    
    results[i,5] = ssim(gt, fbp_recon)
    results[i,6] = ssim(gt, tv_recon)
    results[i,7] = ssim(gt, stage1_recon)
    results[i,8] = ssim(gt, stage2_recon)
    results[i,9] = ssim(gt, stage3_recon)

    
# print((results[:100][:,3] - results[:100][:,1]).argsort()[::-1][:10])

# print((results[100:200][:,3] - results[100:200][:,1]).argsort()[::-1][:10])

# print((results[200:][:,3] - results[200:][:,1]).argsort()[::-1][:10])
    
# print((results[100:200][:,3] - results[100:200][:,1])[49], "see how much improvement")


print(results[:100].mean(axis=0))

print(results[100:200].mean(axis=0))

print(results[200:].mean(axis=0))


# print(
# np.save("results_partial_noise1.npy", results)
    
    
    
