import numpy as np
import matplotlib.pyplot as plt
import numpy.linalg as la
import yaml
import os
num_projs = 25
# num_projs = 30
# num_projs = 20

folder_name = '/data/bowen/SparseReconstruction/3d-ct-full-dose/proj_25_ood'
img_path = '/data/bowen/SparseReconstruction/3d-ct-full-dose/'
gt = np.load("test_fbp_gt.npy")[0,0,:,:].T
plt.imshow(gt, "gray")
image = gt.copy()
shape_min = min(image.shape)
radius = shape_min // 2
img_shape = np.array(image.shape)
coords = np.array(np.ogrid[:gt.shape[0], :gt.shape[1]],
                          dtype=object)
dist = ((coords - img_shape // 2) ** 2).sum(0)
outside_reconstruction_circle = dist > radius ** 2
gt = 0*outside_reconstruction_circle + gt * (1-outside_reconstruction_circle)

def crop_img(img):
    return 0*outside_reconstruction_circle + img * (1-outside_reconstruction_circle)



def set_state(config_file,state_name, value):
    doc = None
    with open(config_file, 'r') as f:
        doc = yaml.safe_load(f)
        doc[state_name] = value
        
    with open(config_file, 'w') as f:
        new_yaml = yaml.dump(doc,f)
        
    
    return 


prefix = 'c'
offset = 0
for i in range(215,216):
    if i >= 100:
        prefix = 'b'
        offset = -100
    if i >= 200:
        prefix = 'a'
        offset = -200
    
    res_path = img_path + prefix + '-' + str(i+offset) + '.npy'
    recon_path = img_path + 'resnerp_denoise/' + 'resrecon_' + prefix + '-' + str(i+offset) + '.npy'
    set_state('configs/ct_recon.yaml', 'num_projs', num_projs)
    set_state('configs/ct_recon.yaml', 'img_path', res_path)
    set_state('configs/ct_recon.yaml', 'recon_name', recon_path) 
    set_state('configs/ct_recon.yaml', 'reg', 'lasso')
    set_state('configs/ct_recon.yaml', 'max_iter', 1500)
    
    set_state('configs/ct_recon.yaml', 'prior_index', i)
    
    os.system('python train_ct_recon2.py --config configs/ct_recon.yaml --output_path  /data/bowen/SparseReconstruction/3d-ct-full-dose/models')  ######output the reconstructed residual, need to crop and clip it with prior to get final recon
    
    prior = np.load("/data/bowen/SparseReconstruction/3d-ct-full-dose/cnn_recon/prior" + str(i) + ".npy")
    res = np.load(recon_path)
    np.save("/data/bowen/SparseReconstruction/3d-ct-full-dose/nerprecon/nerp_recon" + "-" + str(i) + ".npy", np.clip(crop_img((prior + res)[0,:,:,0]),0,1))
    
    
"""    
prefix = 'c'
offset = 0

for i in range(215):
    if i >= 100:
        prefix = 'b'
        offset = -100
    if i >= 200:
        prefix = 'a'
        offset = -200
    
    res_path = img_path + prefix + '-' + str(i+offset) + '.npy'
    recon_path = img_path + 'ridge_boost/' + 'nerp' + prefix + '-' + str(i+offset) + '.npy'
    set_state('configs/ct_recon.yaml', 'num_projs', num_projs)
    set_state('configs/ct_recon.yaml', 'img_path', res_path)
    set_state('configs/ct_recon.yaml', 'recon_name', recon_path) 
    set_state('configs/ct_recon.yaml', 'reg', 'ridge_ata')
    set_state('configs/ct_recon.yaml', 'prior_index', i)
    set_state('configs/ct_recon.yaml', 'max_iter', 400)
    
    os.system('python train_ct_recon2.py --config configs/ct_recon.yaml --output_path  /data/bowen/SparseReconstruction/3d-ct-full-dose/models')  ######output the reconstructed residual, need to crop and clip it with prior to get final recon
    
#     prior = np.load("/data/bowen/SparseReconstruction/3d-ct-full-dose/cnn_recon/prior" + str(i) + ".npy")
#     res = np.load(recon_path)

"""

